      SUBROUTINE PZHEEV3( UPLO, N, A, IA, JA, DESCA, VL, VU,
     $                    ABSTOL, M, W, WORK, LWORK, RWORK, LRWORK,
     $                    IWORK, LIWORK, INFO )
*
* Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            IA, INFO, JA, LIWORK, LRWORK,
     $                   LWORK, M, N,
      DOUBLE PRECISION   ABSTOL, VL, VU
*
* Array Arguments ..
      INTEGER            DESCA( * ), IWORK( * )
      DOUBLE PRECISION   RWORK( * ), W( * )
      COMPLEX*16         A( * ), WORK( * )
*
* Parameters ..
      INTEGER            CTXT_,  MB_, NB_, RSRC_, CSRC_
      PARAMETER          ( CTXT_ = 2, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8 )
      DOUBLE PRECISION   ZERO, ONE, FIVE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0,
     $                   FIVE = 5.0D+0 )
      INTEGER            IERREBZ
      PARAMETER          ( IERREBZ = 8 )
*
* Local Scalars ..
      LOGICAL            LOWER, LQUERY, QUICKRETURN
      CHARACTER          ORDER
      INTEGER            CSRC_A, I, IAROW, ICOFFA, ICTXT, IINFO,
     $                   INDD, INDD2, INDE, INDE2, INDIBL, INDISP,
     $                   INDRWORK, INDTAU, INDWORK, IROFFA
     $                   ISCALE, ISIZESTEBZ, ISIZESTEIN,
     $                   LIWMIN, LLRWORK, LLWORK, LRWMIN,
     $                   LRWOPT, LWMIN, LWOPT, MAXEIGS, MB_A, MQ0,
     $                   MYCOL, MYROW, NB, NB_A, NEIG, NN,
     $                   NNP, NP0, NPCOL, NPROCS, NPROW, NQ0,
     $                   NSPLIT, OFFSET, RSRC_A
      DOUBLE PRECISION   ABSTLL, ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN,
     $                   SIGMA, SMLNUM, VLL, VUU
*
* Local Arrays ..
      INTEGER            IDUM1( 2 ), IDUM2( 2 )
*
* External Functions ..
      LOGICAL            LSAME
      INTEGER            INDXG2P, NUMROC
      DOUBLE PRECISION   PDLAMCH, PZLANHE
      EXTERNAL           LSAME, INDXG2P, NUMROC, PDLAMCH, PZLANHE
*
* External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, CHK1MAT, DGEBR2D, DGEBS2D,
     $                   DLASRT, DSCAL, PCHK1MAT, PDLARED1D,
     $                   PDSTEBZ, PXERBLA, PZELGET, PZHENTRD,
     $                   PZLASCL
*
* Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, ICHAR, MAX, MIN, MOD,
     $                   SQRT
*
* Executable Statements ..
*
      QUICKRETURN = ( N.EQ.0 )
*
* Test the input arguments.
*
      ICTXT = DESCA( CTXT_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      INFO = 0
*
      IF( NPROW.EQ.-1 ) THEN
         INFO = -( 600+CTXT_ )
      END IF
      IF( INFO.EQ.0 ) THEN
         CALL CHK1MAT( N, 2, N, 2, IA, JA, DESCA, 6, INFO )
*
         IF( INFO.EQ.0 ) THEN
*
* Get machine constants.
*
            SAFMIN = PDLAMCH( ICTXT, 'Safe minimum' )
            EPS = PDLAMCH( ICTXT, 'Precision' )
            SMLNUM = SAFMIN / EPS
            BIGNUM = ONE / SMLNUM
            RMIN = SQRT( SMLNUM )
            RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
            NPROCS = NPROW*NPCOL
            LOWER = LSAME( UPLO, 'L' )
*
* Set up pointers into the WORK array
*
            INDTAU = 1
            INDWORK = INDTAU + N
            LLWORK = LWORK - INDWORK + 1
*
* Set up pointers into the RWORK array
*
            INDE = 1
            INDD = INDE + N
            INDD2 = INDD + N
            INDE2 = INDD2 + N
            INDRWORK = INDE2 + N
            LLRWORK = LRWORK - INDRWORK + 1
*
* Set up pointers into the IWORK array
*
            ISIZESTEIN = 3*N + NPROCS + 1
            ISIZESTEBZ = MAX( 4*N, 14, NPROCS )
            INDIBL = ( MAX( ISIZESTEIN, ISIZESTEBZ ) ) + 1
            INDISP = INDIBL + N
*
* Compute the total amount of space needed
*
            LQUERY = .FALSE.
            IF( LWORK.EQ.-1 .OR. LIWORK.EQ.-1 .OR. LRWORK.EQ.-1 )
     $         LQUERY = .TRUE.
*
            NNP = MAX( N, NPROCS+1, 4 )
            LIWMIN = 6*NNP
*
            NPROCS = NPROW*NPCOL
            NB_A = DESCA( NB_ )
            MB_A = DESCA( MB_ )
            NB = NB_A
            NN = MAX( N, NB, 2 )
*
            RSRC_A = DESCA( RSRC_ )
            CSRC_A = DESCA( CSRC_ )
            IROFFA = MOD( IA-1, MB_A )
            ICOFFA = MOD( JA-1, NB_A )
            IAROW = INDXG2P( 1, NB_A, MYROW, RSRC_A, NPROW )
            NP0 = NUMROC( N+IROFFA, NB, 0, 0, NPROW )
            MQ0 = NUMROC( N+ICOFFA, NB, 0, 0, NPCOL )
*
               LWMIN = N + MAX( NB*( NP0+1 ), 3 )
               LWOPT = LWMIN
               LRWMIN = 5*NN + 4*N
               LRWOPT = LRWMIN
               NEIG = 0
*
         END IF
         IF( INFO.EQ.0 ) THEN
            IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
               RWORK( 1 ) = ABSTOL
                  RWORK( 2 ) = VL
                  RWORK( 3 ) = VU
               CALL DGEBS2D( ICTXT, 'ALL', ' ', 3, 1, RWORK, 3 )
            ELSE
               CALL DGEBR2D( ICTXT, 'ALL', ' ', 3, 1, RWORK, 3, 0, 0 )
            END IF
*
            IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
               INFO = -1
            ELSE IF( N.GT.0 .AND. VU.LE.VL ) THEN
               INFO = -8
            ELSE IF( LWORK.LT.LWMIN .AND. LWORK.NE.-1 ) THEN
               INFO = -13
            ELSE IF( LRWORK.LT.LRWMIN .AND. LRWORK.NE.-1 ) THEN
               INFO = -15
            ELSE IF( LIWORK.LT.LIWMIN .AND. LIWORK.NE.-1 ) THEN
               INFO = -17
            ELSE IF( ABS( RWORK( 2 )-VL ).GT.FIVE*EPS*
     $               ABS( VL ) ) THEN
               INFO = -7
            ELSE IF( ABS( RWORK( 3 )-VU ).GT.FIVE*EPS*
     $               ABS( VU ) ) THEN
               INFO = -8
            ELSE IF( ABS( RWORK( 1 )-ABSTOL ).GT.FIVE*EPS*
     $               ABS( ABSTOL ) ) THEN
               INFO = -9
            ELSE IF( IROFFA.NE.0 ) THEN
               INFO = -4
            ELSE IF( DESCA( MB_ ).NE.DESCA( NB_ ) ) THEN
               INFO = -( 600+NB_ )
            END IF
*
         END IF
         IF( LOWER ) THEN
            IDUM1( 1 ) = ICHAR( 'L' )
         ELSE
            IDUM1( 1 ) = ICHAR( 'U' )
         END IF
         IDUM2( 1 ) = 1
         IF( LQUERY ) THEN
            IDUM1( 2 ) = -1
         ELSE
            IDUM1( 2 ) = 1
         END IF
         IDUM2( 2 ) = 2
            CALL PCHK1MAT( N, 2, N, 2, IA, JA, DESCA, 6, 2, IDUM1,
     $                     IDUM2, INFO )
*
         WORK( 1 ) = DCMPLX( LWOPT )
         RWORK( 1 ) = DBLE( LRWOPT )
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( ICTXT, 'PZHEEV3', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
* Quick return if possible
*
      IF( QUICKRETURN ) THEN
         M = 0
         WORK( 1 ) = DCMPLX( LWOPT )
         RWORK( 1 ) = DBLE( LRWMIN )
         IWORK( 1 ) = LIWMIN
         RETURN
      END IF
*
* Scale matrix to allowable range, if necessary.
*
      ABSTLL = ABSTOL
      ISCALE = 0
         VLL = VL
         VUU = VU
*
      ANRM = PZLANHE( 'M', UPLO, N, A, IA, JA, DESCA,
     $       RWORK( INDRWORK ) )
*
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
         ANRM = ANRM*SIGMA
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
         ANRM = ANRM*SIGMA
      END IF
*
      IF( ISCALE.EQ.1 ) THEN
         CALL PZLASCL( UPLO, ONE, SIGMA, N, N, A, IA, JA, DESCA, IINFO )
         IF( ABSTOL.GT.0 )
     $      ABSTLL = ABSTOL*SIGMA
            VLL = VL*SIGMA
            VUU = VU*SIGMA
            IF( VUU.EQ.VLL ) THEN
               VUU = VUU + 2*MAX( ABS( VUU )*EPS, SAFMIN )
            END IF
      END IF
*
* Call PZHENTRD to reduce Hermitian matrix to tridiagonal form.
*
      CALL PZHENTRD( UPLO, N, A, IA, JA, DESCA, RWORK( INDD ),
     $               RWORK( INDE ), WORK( INDTAU ), WORK( INDWORK ),
     $               LLWORK, RWORK( INDRWORK ), LLRWORK, IINFO )
*
*
* Copy the values of D, E to all processes
*
* Here PDLARED1D is used to redistribute the tridiagonal matrix.
* PDLARED1D, however, doesn't yet work with arbritary matrix
* distributions so we have PDELGET as a backup.
*
      OFFSET = 0
      IF( IA.EQ.1 .AND. JA.EQ.1 .AND. RSRC_A.EQ.0 .AND. CSRC_A.EQ.0 )
     $     THEN
         CALL PDLARED1D( N, IA, JA, DESCA, RWORK( INDD ),
     $                   RWORK( INDD2 ), RWORK( INDRWORK ), LLRWORK )
*
         CALL PDLARED1D( N, IA, JA, DESCA, RWORK( INDE ),
     $                   RWORK( INDE2 ), RWORK( INDRWORK ), LLRWORK )
         IF( .NOT.LOWER )
     $      OFFSET = 1
      ELSE
         DO 10 I = 1, N
            CALL PZELGET( 'A', ' ', WORK( INDD2+I-1 ), A, I+IA-1,
     $                    I+JA-1, DESCA )
            RWORK( INDD2+I-1 ) = DBLE( WORK( INDD2+I-1 ) )
   10    CONTINUE
         IF( LSAME( UPLO, 'U' ) ) THEN
            DO 20 I = 1, N - 1
               CALL PZELGET( 'A', ' ', WORK( INDE2+I-1 ), A, I+IA-1,
     $                       I+JA, DESCA )
               RWORK( INDE2+I-1 ) = DBLE( WORK( INDE2+I-1 ) )
   20       CONTINUE
         ELSE
            DO 30 I = 1, N - 1
               CALL PZELGET( 'A', ' ', WORK( INDE2+I-1 ), A, I+IA,
     $                       I+JA-1, DESCA )
               RWORK( INDE2+I-1 ) = DBLE( WORK( INDE2+I-1 ) )
   30       CONTINUE
         END IF
      END IF
*
* Call PDSTEBZ.
*
         ORDER = 'E'
*
      CALL PDSTEBZ( ICTXT, 'V', ORDER, N, VLL, VUU, 0, 0, ABSTLL,
     $              RWORK( INDD2 ), RWORK( INDE2+OFFSET ), M, NSPLIT, W,
     $              IWORK( INDIBL ), IWORK( INDISP ), RWORK( INDRWORK ),
     $              LLRWORK, IWORK( 1 ), ISIZESTEBZ, IINFO )
*
* IF PDSTEBZ fails, the error propogates to INFO, but
* we do not propogate the eigenvalue(s) which failed because:
*   This should never happen if the user specifies
*     ABSTOL = 2 * PDLAMCH( 'U' )
*
      IF( IINFO.NE.0 ) THEN
         INFO = INFO + IERREBZ
         DO 40 I = 1, M
            IWORK( INDIBL+I-1 ) = ABS( IWORK( INDIBL+I-1 ) )
   40    CONTINUE
      END IF
*
* If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( M, ONE / SIGMA, W, 1 )
      END IF
*
      WORK( 1 ) = DCMPLX( LWOPT )
      RWORK( 1 ) = DBLE( LRWOPT )
      IWORK( 1 ) = LIWMIN
*
      RETURN
*
*     End of PZHEEV3
*
      END
